#!/bin/sh

Result=1

RemoveDir()
{
	target="$1"

	if [ -e "${target}" ] ; then
		/bin/rm -R "${target}"
		ret=$?
		if [ $ret -eq 0 ] ; then
			Result=0
		else
			echo "Failed to remove ${target}"
			return 1
		fi
	else
		echo "Not found ${target}"
		return 1
	fi

	return 0
}

RemoveDirIfEmpty()
{
	target="$1"

	if [ -e "${target}" ] ; then
		search=`/bin/ls -A "$1" 2> /dev/null`
		if [ -z "${search}" -o "${search}" = ".DS_Store" ] ; then
			/bin/rm -R "${target}"
			ret=$?
			if [ $ret -ne 0 ] ; then
				echo "Failed to remove ${target}"
				return 1
			fi
		fi
	else
		echo "Not found ${target}"
		return 1
	fi

	return 0
}

RemoveFile()
{
	target="$1"

	if [ -f "${target}" ] ; then
		/bin/rm -R "${target}"
		ret=$?
		if [ $ret -eq 0 ] ; then
			Result=0
		else
			echo "Failed to remove ${target}"
			return 1
		fi
	else
		echo "Not found ${target}"
		return 1
	fi

	return 0
}

RemoveReceipt()
{
	target="$1"

	if  pkgutil --pkg-info "${target}" ; then
		pkgutil --forget   "${target}"
	fi

	return 0
}

# Kext
RemoveDir "/System/Library/Extensions/ZOOM R16USBAudio.kext"
RemoveDir "/Library/Extensions/ZOOM R16USBAudio.kext"

# HAL Plug-In
RemoveDir "/Library/Audio/Plug-Ins/HAL/ZOOM R16 USB Audio.driver"

# USB MIDI Driver
RemoveDir "/Library/Audio/MIDI Drivers/ZOOM R16USBMidi.plugin"

# MIDI device image file
RemoveFile "/Library/Audio/MIDI Devices/ZOOM/Images/R16.tiff"
RemoveFile "/Library/Audio/MIDI Devices/ZOOM/Images/R16.png"
RemoveDirIfEmpty "/Library/Audio/MIDI Devices/ZOOM/Images"
RemoveDirIfEmpty "/Library/Audio/MIDI Devices/ZOOM"

# Control Panel
RemoveDir "/Library/PreferencePanes/ZOOM R16ControlPanel.prefPane"

# Device Manager
RemoveDir "/Library/Application Support/ZOOM/R16/ZOOM R16DeviceManager.app"
RemoveDirIfEmpty "/Library/Application Support/ZOOM/R16"
RemoveDirIfEmpty "/Library/Application Support/ZOOM"

# LaunchAgents info file
RemoveFile "/Library/LaunchAgents/com.zoom.R16DeviceManager.plist"

# Installer Receipt
RemoveReceipt "jp.co.zoom.R16Audio.installer"
RemoveReceipt "jp.co.zoom.R16Audio.installer.IOUSBLib"

if [ -e /usr/bin/kmutil ]; then
    /usr/bin/kmutil clear-staging;
fi

if [[ `/usr/bin/sw_vers -productVersion` == 10.15.* ]]; then
    /usr/sbin/kextcache --clear-staging;
fi

exit ${Result}
